pipeline {
    agent any
    
   stages {    
        
      stage('SCM') {
         steps {
            git 'https://gitlab.com/kandra.vignesh4/fooddeliverywebsite.git'
         }
      } 
        
      stage('Build Project') {
         steps {
            sh label: '', script: '''
                sudo -s
                sudo apt install nodejs -y
                apt-get install npm -y

                npm i -g npm-check-updates -y
                ncu -u 

                sudo apt-get update   -y              
                
                sudo npm install -y
                sudo npm run build
            '''
         }
      }
    
  
    
    stage('Docker Image'){
        steps{
            sh label: '', script: '''

            sudo docker build -t vigneshkandra/food-delivery-app .
            
             '''
           }
    }






stage('docker') {
    steps{
    withCredentials([usernamePassword(credentialsId: 'docker_hub_vigneshkandra', passwordVariable: 'Vignesh@1', usernameVariable: 'vigneshkandra')]) {
    echo 'logged in'

        sh label: '', script: '''    
        docker push vigneshkandra/food-delivery-app
        '''   
         }   
        
        }
    }
  stage('AWS Connection and Deployment'){
            steps{
                   sh 'AWS Connection and Deployment'
                   sshagent(['AWS_Deployment_Server']) {
                   sh "ssh -o StrictHostKeyChecking=no ubuntu@15.206.166.205 sudo docker run -t -p 3000:3000 vigneshkandra/food-delivery-app up -d"
                   }
            }
        }
    }
   
      
        
   } 
   post {
        always {
           
          
            emailext attachLog: true,
                body: "${currentBuild.currentResult}: Job ${env.JOB_NAME} build ${env.BUILD_NUMBER}\n More info at: ${env.BUILD_URL}",
                recipientProviders: [developers(), requestor()],
                subject: "Jenkins Build :- ${currentBuild.currentResult}: Job ${env.JOB_NAME}"
            
        }
    }
